package com.fr.design.form.util;

import com.fr.design.file.HistoryTemplateListCache;
import com.fr.design.mainframe.FormDesigner;
import com.fr.design.mainframe.JTemplate;
import com.fr.design.mainframe.template.info.ComponentCreateOperate;
import com.fr.design.mainframe.template.info.ComponentDeleteOperate;
import com.fr.form.ui.Widget;
import com.fr.form.ui.container.WFitLayout;


public class FormDesignerUtils {
    /**
     * body布局是否设置了手机重布局
     *
     * @param designer
     * @return
     */
    public static boolean isAppRelayout(FormDesigner designer) {
        return ((WFitLayout) designer.getRootComponent().toData()).isAppRelayout();
    }

    /**
     * body布局是否设置了绝对布局
     *
     * @param designer
     * @return
     */
    public static boolean isBodyAbsolute(FormDesigner designer) {
        WFitLayout root = ((WFitLayout) designer.getRootComponent().toData());
        return root.getBodyLayoutType() == com.fr.form.ui.container.WBodyLayoutType.ABSOLUTE;
    }


    public static void addWidgetProcessInfo(Widget widget) {
        JTemplate jTemplate = HistoryTemplateListCache.getInstance().getCurrentEditingTemplate();
        jTemplate.getProcessInfo().updateTemplateOperationInfo(new ComponentCreateOperate(widget));
    }

    public static void removeWidgetProcessInfo(Widget widget) {
        JTemplate jTemplate = HistoryTemplateListCache.getInstance().getCurrentEditingTemplate();
        jTemplate.getProcessInfo().updateTemplateOperationInfo(new ComponentDeleteOperate(widget));
    }

}
